/*{ ttc_basic.c ***********************************************
 *
 * TheToolChain.com
 *
 * Written by Gregor Rebel 2010-2011
 *
 * Basic set of helper functions.
 * 
}*/
#include "ttc_basic.h"

bool Assert(volatile bool Condition, volatile ErrorCode_e ErrorCode) {  // block endless in case Condition is false
    volatile bool HoldOnAssert=TRUE;

    if (HoldOnAssert) {
        while (!Condition)
            ErrorCode=ErrorCode; // <-- breakpoint here!
    }

    return Condition; // Only reachable if HoldOnAssert==FALSE
}
u8_t strnlen__8(const char* String, u8_t MaxLen) {
    u8_t Length = 0;

    while ( (MaxLen > 0) && (*String != 0) ) {
        MaxLen--;
        String++;
        Length++;
    }
    return Length;
}
u16_t strnlen__16(const char* String, u16_t MaxLen) {
    u16_t Length = 0;

    while ( (MaxLen > 0) && (*String != 0) ) {
        MaxLen--;
        String++;
        Length++;
    }
    return Length;
}
u32_t strnlen__32(const char* String, u32_t MaxLen) {
    u32_t Length = 0;

    while ( (MaxLen > 0) && (*String != 0) ) {
        MaxLen--;
        String++;
        Length++;
    }
    return Length;
}
