/*{ ttc_gpio.c ***********************************************
 *
 * Written by Gregor Rebel 2010-2012
 *
}*/

#include "ttc_gpio.h"

void ttc_initPort(ttc_Port_t* Port, ttc_GPIO_BANK GPIOx, u32_t Pin, ttc_gpio_mode_e Type) {
    ttc_initPort2(Port, GPIOx, Pin, Type, tgs_Max);
}
void ttc_initPort2(ttc_Port_t* Port, ttc_GPIO_BANK GPIOx, u32_t Pin, ttc_gpio_mode_e Type, ttc_gpio_speed_e Speed) {
#ifdef TARGET_ARCHITECTURE_STM32
    #define TTC_INIT_PORT2
    stm32_loadPort(Port, GPIOx, Pin);
    stm32_initPort2( Port, stm32_map_Type(Type), stm32_map_Speed(Speed) );
#endif

#ifndef TTC_INIT_PORT2
  #warning Missing low level implementation for ttc_initPort2()
#endif
}
void ttc_loadPort(ttc_Port_t* Port, ttc_GPIO_BANK GPIOx, u32_t Pin) {
#ifdef TARGET_ARCHITECTURE_STM32
    #define TTC_LOAD_PORT
    stm32_loadPort(Port, GPIOx, Pin);
#endif

#ifndef TTC_LOAD_PORT
  #warning Missing low level implementation for ttc_loadPort()
#endif
}
bool ttc_portGet(ttc_Port_t* Port) {
#ifdef TARGET_ARCHITECTURE_STM32
    #define TTC_PORT_GET
    return stm32_portGet(Port);
#endif

#ifndef TTC_PORT_GET
  #warning Missing low level implementation for ttc_portGet()
#endif
  return 0;
}
void ttc_portSet(ttc_Port_t* Port) {
#ifdef TARGET_ARCHITECTURE_STM32
    #define TTC_PORT_SET
    stm32_portSet(Port);
#endif


#ifndef TTC_PORT_SET
  #warning Missing low level implementation for ttc_portSet()
#endif
}
void ttc_portClr(ttc_Port_t* Port) {
#ifdef TARGET_ARCHITECTURE_STM32
    #define TTC_PORT_CLR
    stm32_portClr(Port);
#endif


#ifndef TTC_PORT_CLR
  #warning Missing low level implementation for ttc_portClr()
#endif
}
