/*{ ttc_spi::.c ************************************************
 
                      The ToolChain
                      
   Device independent support for 
   
   
   written by Gregor Rebel 2012
   
 
}*/

#include "ttc_spi.h"

//{ Function definitions *************************************************

inline                u8_t ttc_spi_get_max_index() {

    return TTC_AMOUNT_SPIS; // -> ttc_spi_types.h
}
inline ttc_spi_errorcode_e ttc_spi_get_defaults(u8_t SPI_Index, ttc_spi_generic_t* SPI_Generic) {
    memset(SPI_Generic, 0, sizeof(SPI_Generic));
    
#ifdef TARGET_ARCHITECTURE_STM32
    return stm32_spi_get_defaults(SPI_Index, SPI_Generic);
#endif

  return tse_NotImplemented;
}
inline ttc_spi_errorcode_e ttc_spi_get_features(u8_t SPI_Index, ttc_spi_generic_t* SPI_Generic) {
    memset(SPI_Generic, 0, sizeof(SPI_Generic));
    
#ifdef TARGET_ARCHITECTURE_STM32
    return stm32_spi_get_features(SPI_Index, SPI_Generic);
#endif

  return tse_NotImplemented;
}
inline ttc_spi_errorcode_e ttc_spi_init(u8_t SPI_Index, ttc_spi_generic_t* SPI_Generic, ttc_spi_architecture_t* SPI_Arch) {
    memset(SPI_Arch, 0, sizeof(SPI_Arch));

#ifdef TARGET_ARCHITECTURE_STM32
  return stm32_spi_init(SPI_Index, SPI_Generic, (stm32_spi_architecture_t*) SPI_Arch);
#endif

  return tse_NotImplemented;
}
inline ttc_spi_errorcode_e ttc_spi_send_raw(u8_t SPI_Index, const char* Buffer, u16_t Amount) {
  
#ifdef TARGET_ARCHITECTURE_STM32
  return stm32_spi_send_raw(SPI_Index, Buffer, Amount);
#endif

  return tse_NotImplemented;
}
inline ttc_spi_errorcode_e ttc_spi_send_string(u8_t SPI_Index, const char* Buffer, u16_t MaxLength) {
  
#ifdef TARGET_ARCHITECTURE_STM32
  return stm32_spi_send_string(SPI_Index, Buffer, MaxLength);
#endif

  return tse_NotImplemented;
}
inline ttc_spi_errorcode_e ttc_spi_send_word(u8_t SPI_Index, const u16_t Word) {

#ifdef TARGET_ARCHITECTURE_STM32
  return stm32_spi_send_word(SPI_Index, Word);
#endif

  return tse_NotImplemented;
}
inline ttc_spi_errorcode_e ttc_spi_read_word(u8_t SPI_Index, u16_t* Word, u32_t TimeOut) {

#ifdef TARGET_ARCHITECTURE_STM32
  return stm32_spi_read_word(SPI_Index, Word, TimeOut);
#endif

  return tse_NotImplemented;
}
inline ttc_spi_errorcode_e ttc_spi_read_byte(u8_t SPI_Index, char* Byte, u32_t TimeOut) {

#ifdef TARGET_ARCHITECTURE_STM32
  return stm32_spi_read_byte(SPI_Index, Byte, TimeOut);
#endif

  return tse_NotImplemented;
}

//} Function definitions
